package com.annimon.ownlang.parser.ast;

import com.annimon.ownlang.lib.ArrayValue;
import com.annimon.ownlang.lib.Value;
import java.util.Vector;

/**
 *
 * @author aNNiMON
 */
public final class ArrayExpression implements Expression {
    
    public final Vector/*<Expression>*/ elements;

    public ArrayExpression(Vector/*<Expression>*/ arguments) {
        this.elements = arguments;
    }
    
    /*@Override*/
    public Value eval() {
        final int size = elements.size();
        final ArrayValue array = new ArrayValue(size);
        for (int i = 0; i < size; i++) {
            array.set(i, ((Expression) elements.elementAt(i)).eval());
        }
        return array;
    }
    
    /*@Override*/
    public void accept(Visitor visitor) {
        visitor.visit(this);
    }

    /*@Override*/
    public String toString() {
        return elements.toString();
    }
}
