package com.annimon.stream;

import com.annimon.stream.function.BiConsumer;
import com.annimon.stream.function.Function;
import com.annimon.stream.function.Supplier;
import java.util.Vector;

/**
 * Common implementations of {@link Collector}.
 * 
 * @author aNNiMON
 */
public final class Collectors {
    
    public static Collector toList() {
        return new Collector() {

            public Supplier supplier() {
                return new Supplier() {
                    public Object get() {
                        return new Vector();
                    }
                };
            }

            public BiConsumer accumulator() {
                return new BiConsumer() {
                    public void accept(Object t, Object u) {
                        ((Vector) t).addElement(u);
                    }
                };
            }

            public Function finisher() {
                return null;
            }
        };
    }
}
