package com.annimon.ownlang.parser.ast;

import java.util.Enumeration;
import java.util.Vector;

/**
 *
 * @author aNNiMON
 */
public final class BlockStatement implements Statement {
    
    public final Vector/*<Statement>*/ statements;

    public BlockStatement() {
        statements = new Vector/*<>*/();
    }
    
    public void add(Statement statement) {
        statements.addElement(statement);
    }

    /*@Override*/
    public void execute() {
        for (Enumeration en = statements.elements(); en.hasMoreElements();) {
            ((Statement) en.nextElement()).execute();
        }
    }
    
    /*@Override*/
    public void accept(Visitor visitor) {
        visitor.visit(this);
    }

    /*@Override*/
    public String toString() {
        final StringBuffer result = new StringBuffer();
        for (Enumeration en = statements.elements(); en.hasMoreElements();) {
            result.append(((Statement) en.nextElement()).toString())
                    .append("\n");
        }
        return result.toString();
    }
}
